import { __assign, __read, __rest } from "tslib";
import React, { useState } from 'react';
import { BarChart, ResponsiveWrapper, SeriesLegend, theme as defaultTheme, } from '@keen.io/charts';
import { useLegend, useDataSeriesOffset } from '@keen.io/react-hooks';
import { getOffsetRangeColor } from '@keen.io/charts-utils';
import ChartWidget from '../chart-widget';
import WidgetHeading from '../widget-heading.component';
import { legendSettings } from '../../widget-settings';
export var BarChartWidget = function (_a) {
    var _b = _a.legend, legend = _b === void 0 ? legendSettings : _b, _c = _a.theme, theme = _c === void 0 ? defaultTheme : _c, title = _a.title, subtitle = _a.subtitle, card = _a.card, tags = _a.tags, props = __rest(_a, ["legend", "theme", "title", "subtitle", "card", "tags"]);
    var _d = useLegend(), disabledKeys = _d.disabledKeys, updateKeys = _d.updateKeys;
    var _e = __read(useState(null), 2), activeKey = _e[0], setActiveKey = _e[1];
    var _f = useDataSeriesOffset(theme.colors.length, legend.enabled), setDataSeriesOffset = _f.setDataSeriesOffset, dataSeriesOffset = _f.dataSeriesOffset;
    return (React.createElement(ChartWidget, { cardSettings: card, legendSettings: {
            position: legend.position,
            alignment: legend.alignment,
            layout: legend.layout,
        }, title: function () { return (React.createElement(WidgetHeading, { title: title, subtitle: subtitle, tags: tags })); }, legend: function () {
            return legend.enabled && (React.createElement(SeriesLegend, __assign({}, legend, { disabledKeys: disabledKeys, onClick: updateKeys, onActivate: function (label) { return setActiveKey(label); }, onDeactivate: function () { return setActiveKey(null); }, colorPalette: theme.colors, dataSeries: props.keys.map(function (key, idx) { return ({
                    name: key,
                    color: getOffsetRangeColor(idx, theme.colors, dataSeriesOffset),
                }); }), onOffsetUpdate: function (offset) { return setDataSeriesOffset(offset); } })));
        }, content: function () { return (React.createElement(ResponsiveWrapper, null, function (width, height) { return (React.createElement(BarChart, __assign({ theme: theme, disabledKeys: disabledKeys, activeKey: activeKey, svgDimensions: { width: width, height: height }, dataSeriesOffset: dataSeriesOffset }, props))); })); } }));
};
export default BarChartWidget;
