import { __assign, __read, __rest } from "tslib";
import React, { useState } from 'react';
import { PieChart, ResponsiveWrapper, SeriesLegend, theme as defaultTheme, } from '@keen.io/charts';
import { useLegend, useDataSeriesOffset } from '@keen.io/react-hooks';
import WidgetHeading from '../widget-heading.component';
import ChartWidget from '../chart-widget';
import { createLegendLabels } from './pie-chart.widget.utils';
import { legendSettings } from '../../widget-settings';
export var PieChartWidget = function (_a) {
    var _b = _a.legend, legend = _b === void 0 ? legendSettings : _b, _c = _a.theme, theme = _c === void 0 ? defaultTheme : _c, title = _a.title, subtitle = _a.subtitle, card = _a.card, tags = _a.tags, props = __rest(_a, ["legend", "theme", "title", "subtitle", "card", "tags"]);
    var _d = useLegend(), disabledKeys = _d.disabledKeys, updateKeys = _d.updateKeys;
    var _e = __read(useState([]), 2), sortedDataSeries = _e[0], setSortedDataSeries = _e[1];
    var _f = __read(useState(null), 2), activeKey = _f[0], setActiveKey = _f[1];
    var _g = useDataSeriesOffset(theme.colors.length, legend.enabled), setDataSeriesOffset = _g.setDataSeriesOffset, dataSeriesOffset = _g.dataSeriesOffset;
    return (React.createElement(ChartWidget, { cardSettings: card, legendSettings: {
            position: legend.position,
            alignment: legend.alignment,
            layout: legend.layout,
        }, title: function () { return (React.createElement(WidgetHeading, { title: title, subtitle: subtitle, tags: tags })); }, legend: function () {
            return legend.enabled &&
                !!sortedDataSeries.length && (React.createElement(SeriesLegend, __assign({}, legend, { disabledKeys: disabledKeys, onClick: function (key, disabled) {
                    updateKeys(key, disabled);
                }, onActivate: function (label) { return setActiveKey(label); }, onDeactivate: function () { return setActiveKey(null); }, colorPalette: theme.colors, dataSeries: createLegendLabels(sortedDataSeries, theme.colors, dataSeriesOffset), onOffsetUpdate: function (offset) { return setDataSeriesOffset(offset); } })));
        }, content: function () { return (React.createElement(ResponsiveWrapper, null, function (width, height) { return (React.createElement(PieChart, __assign({}, props, { onFinalDataStack: function (res) { return setSortedDataSeries(res); }, disabledLabels: disabledKeys, svgDimensions: { width: width, height: height }, activeKey: activeKey, theme: theme, dataSeriesOffset: dataSeriesOffset }))); })); } }));
};
export default PieChartWidget;
