import { Typography, Position, Alignment, Layout, CardSettings } from '@keen.io/ui-core';
import { colors } from '@keen.io/colors';
export declare type Widgets = 'bar' | 'line' | 'area' | 'pie' | 'donut' | 'gauge' | 'metric' | 'funnel' | 'choropleth' | 'bubble' | 'heatmap' | 'table';
export declare type LegendSettings = {
    enabled: boolean;
    position: Position;
    alignment: Alignment;
    layout: Layout;
    typography: Typography;
    card: {
        backgroundColor?: string;
        border?: string;
        borderRadius?: string;
        hasShadow?: boolean;
    };
    title: {
        value?: string;
        typography?: Typography;
    };
};
export declare type TextSettings = {
    content: string;
    typography: Typography;
};
export declare type WidgetSettings = {
    title?: TextSettings;
    subtitle?: TextSettings;
    card?: CardSettings;
    tags?: Tag[];
    legend?: LegendSettings;
    geographicArea?: 'us' | 'world';
};
export declare type BubbleWidgetLegendSettings = {
    position: Position;
    series?: Omit<LegendSettings, 'position'>;
    bubble?: Omit<LegendSettings, 'position'>;
};
export declare type Tag = {
    label: string;
    variant: keyof typeof colors;
};
